# This file was generated by liblab | https://liblab.com/

from enum import Enum
from .utils.json_map import JsonMap
from .utils.base_model import BaseModel
from .utils.sentinel import SENTINEL


class AgentAgentType(Enum):
    """An enumeration representing different categories.

    :cvar STANDARD: "standard"
    :vartype STANDARD: str
    :cvar PLATFORMAGENT: "platform_agent"
    :vartype PLATFORMAGENT: str
    """

    STANDARD = "standard"
    PLATFORMAGENT = "platform_agent"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, AgentAgentType._member_map_.values()))


@JsonMap({})
class Agent(BaseModel):
    """Agent

    :param agent_id: agent_id
    :type agent_id: str
    :param name: name
    :type name: str
    :param description: description
    :type description: str
    :param system_prompt: system_prompt, defaults to None
    :type system_prompt: str, optional
    :param version: version, defaults to None
    :type version: str, optional
    :param agent_type: agent_type
    :type agent_type: AgentAgentType
    :param platform_url: platform_url, defaults to None
    :type platform_url: str, optional
    :param http_method: http_method, defaults to None
    :type http_method: str, optional
    :param request_template: request_template, defaults to None
    :type request_template: dict, optional
    :param response_config: response_config, defaults to None
    :type response_config: dict, optional
    """

    def __init__(
        self,
        agent_id: str,
        name: str,
        description: str,
        agent_type: AgentAgentType,
        system_prompt: str = SENTINEL,
        version: str = SENTINEL,
        platform_url: str = SENTINEL,
        http_method: str = SENTINEL,
        request_template: dict = SENTINEL,
        response_config: dict = SENTINEL,
        **kwargs
    ):
        """Agent

        :param agent_id: agent_id
        :type agent_id: str
        :param name: name
        :type name: str
        :param description: description
        :type description: str
        :param system_prompt: system_prompt, defaults to None
        :type system_prompt: str, optional
        :param version: version, defaults to None
        :type version: str, optional
        :param agent_type: agent_type
        :type agent_type: AgentAgentType
        :param platform_url: platform_url, defaults to None
        :type platform_url: str, optional
        :param http_method: http_method, defaults to None
        :type http_method: str, optional
        :param request_template: request_template, defaults to None
        :type request_template: dict, optional
        :param response_config: response_config, defaults to None
        :type response_config: dict, optional
        """
        self.agent_id = agent_id
        self.name = name
        self.description = description
        if system_prompt is not SENTINEL:
            self.system_prompt = system_prompt
        if version is not SENTINEL:
            self.version = version
        self.agent_type = self._enum_matching(
            agent_type, AgentAgentType.list(), "agent_type"
        )
        if platform_url is not SENTINEL:
            self.platform_url = platform_url
        if http_method is not SENTINEL:
            self.http_method = http_method
        if request_template is not SENTINEL:
            self.request_template = request_template
        if response_config is not SENTINEL:
            self.response_config = response_config
        self._kwargs = kwargs
