# This file was generated by liblab | https://liblab.com/

from enum import Enum
from typing import Union
from .utils.json_map import JsonMap
from .utils.base_model import BaseModel
from .utils.sentinel import SENTINEL


class AgentCreateAgentType(Enum):
    """An enumeration representing different categories.

    :cvar STANDARD: "standard"
    :vartype STANDARD: str
    :cvar PLATFORMAGENT: "platform_agent"
    :vartype PLATFORMAGENT: str
    """

    STANDARD = "standard"
    PLATFORMAGENT = "platform_agent"

    def list():
        """Lists all category values.

        :return: A list of all category values.
        :rtype: list
        """
        return list(map(lambda x: x.value, AgentCreateAgentType._member_map_.values()))


@JsonMap({})
class AgentCreate(BaseModel):
    """AgentCreate

    :param name: name
    :type name: str
    :param description: description
    :type description: str
    :param system_prompt: system_prompt, defaults to None
    :type system_prompt: str, optional
    :param agent_type: agent_type
    :type agent_type: AgentCreateAgentType
    :param platform_url: platform_url, defaults to None
    :type platform_url: str, optional
    :param http_method: http_method, defaults to None
    :type http_method: str, optional
    :param request_template: request_template, defaults to None
    :type request_template: dict, optional
    :param response_config: response_config, defaults to None
    :type response_config: dict, optional
    """

    def __init__(
        self,
        name: str,
        description: str,
        agent_type: AgentCreateAgentType,
        system_prompt: Union[str, None] = SENTINEL,
        platform_url: Union[str, None] = SENTINEL,
        http_method: Union[str, None] = SENTINEL,
        request_template: Union[dict, None] = SENTINEL,
        response_config: Union[dict, None] = SENTINEL,
        **kwargs
    ):
        """AgentCreate

        :param name: name
        :type name: str
        :param description: description
        :type description: str
        :param system_prompt: system_prompt, defaults to None
        :type system_prompt: str, optional
        :param agent_type: agent_type
        :type agent_type: AgentCreateAgentType
        :param platform_url: platform_url, defaults to None
        :type platform_url: str, optional
        :param http_method: http_method, defaults to None
        :type http_method: str, optional
        :param request_template: request_template, defaults to None
        :type request_template: dict, optional
        :param response_config: response_config, defaults to None
        :type response_config: dict, optional
        """
        self.name = name
        self.description = description
        if system_prompt is not SENTINEL:
            self.system_prompt = self._define_str(
                "system_prompt", system_prompt, nullable=True
            )
        self.agent_type = self._enum_matching(
            agent_type, AgentCreateAgentType.list(), "agent_type"
        )
        if platform_url is not SENTINEL:
            self.platform_url = self._define_str(
                "platform_url", platform_url, nullable=True
            )
        if http_method is not SENTINEL:
            self.http_method = self._define_str(
                "http_method", http_method, nullable=True
            )
        if request_template is not SENTINEL:
            self.request_template = request_template
        if response_config is not SENTINEL:
            self.response_config = response_config
        self._kwargs = kwargs
