# This file was generated by liblab | https://liblab.com/

from __future__ import annotations
from typing import List
from typing import Union
from .utils.json_map import JsonMap
from .utils.base_model import BaseModel
from .utils.sentinel import SENTINEL
from .thread_message import ThreadMessage


@JsonMap({})
class Thread(BaseModel):
    """Thread

    :param thread_id: thread_id
    :type thread_id: str
    :param conversation_id: conversation_id, defaults to None
    :type conversation_id: str, optional
    :param messages: messages
    :type messages: List[ThreadMessage]
    """

    def __init__(
        self,
        thread_id: str,
        messages: List[ThreadMessage],
        conversation_id: Union[str, None] = SENTINEL,
        **kwargs,
    ):
        """Thread

        :param thread_id: thread_id
        :type thread_id: str
        :param conversation_id: conversation_id, defaults to None
        :type conversation_id: str, optional
        :param messages: messages
        :type messages: List[ThreadMessage]
        """
        self.thread_id = thread_id
        if conversation_id is not SENTINEL:
            self.conversation_id = self._define_str(
                "conversation_id", conversation_id, nullable=True
            )
        self.messages = self._define_list(messages, ThreadMessage)
        self._kwargs = kwargs
