# This file was generated by liblab | https://liblab.com/

from .utils.json_map import JsonMap
from .utils.base_model import BaseModel
from .utils.sentinel import SENTINEL


@JsonMap({})
class ThreadMessage(BaseModel):
    """ThreadMessage

    :param user_id: user_id
    :type user_id: str
    :param request_data: request_data
    :type request_data: dict
    :param response_data: response_data, defaults to None
    :type response_data: dict, optional
    :param agent_called: agent_called
    :type agent_called: str
    :param timestamp: timestamp
    :type timestamp: str
    """

    def __init__(
        self,
        user_id: str,
        request_data: dict,
        agent_called: str,
        timestamp: str,
        response_data: dict = SENTINEL,
        **kwargs
    ):
        """ThreadMessage

        :param user_id: user_id
        :type user_id: str
        :param request_data: request_data
        :type request_data: dict
        :param response_data: response_data, defaults to None
        :type response_data: dict, optional
        :param agent_called: agent_called
        :type agent_called: str
        :param timestamp: timestamp
        :type timestamp: str
        """
        self.user_id = user_id
        self.request_data = request_data
        if response_data is not SENTINEL:
            self.response_data = response_data
        self.agent_called = agent_called
        self.timestamp = timestamp
        self._kwargs = kwargs
