# This file was generated by liblab | https://liblab.com/

from typing import Union
from .services.system import SystemService
from .services.agents import AgentsService
from .services.execution import ExecutionService
from .services.analysis import AnalysisService
from .services.schema import SchemaService
from .services.threads import ThreadsService
from .net.environment import Environment


class HeadlessAgents:
    def __init__(
        self,
        api_key: str = None,
        base_url: Union[Environment, str] = Environment.DEFAULT,
        timeout: int = 60000,
    ):
        """
        Initializes HeadlessAgents the SDK class.
        """

        self._base_url = (
            base_url.value if isinstance(base_url, Environment) else base_url
        )
        self.system = SystemService(base_url=self._base_url)
        self.agents = AgentsService(base_url=self._base_url)
        self.execution = ExecutionService(base_url=self._base_url)
        self.analysis = AnalysisService(base_url=self._base_url)
        self.schema = SchemaService(base_url=self._base_url)
        self.threads = ThreadsService(base_url=self._base_url)
        self.set_api_key(api_key)
        self.set_timeout(timeout)

    def set_base_url(self, base_url: Union[Environment, str]):
        """
        Sets the base URL for the entire SDK.

        :param Union[Environment, str] base_url: The base URL to be set.
        :return: The SDK instance.
        """
        self._base_url = (
            base_url.value if isinstance(base_url, Environment) else base_url
        )

        self.system.set_base_url(self._base_url)
        self.agents.set_base_url(self._base_url)
        self.execution.set_base_url(self._base_url)
        self.analysis.set_base_url(self._base_url)
        self.schema.set_base_url(self._base_url)
        self.threads.set_base_url(self._base_url)

        return self

    def set_api_key(self, api_key: str):
        """
        Sets the api key for the entire SDK.
        """
        self.system.set_api_key(api_key)
        self.agents.set_api_key(api_key)
        self.execution.set_api_key(api_key)
        self.analysis.set_api_key(api_key)
        self.schema.set_api_key(api_key)
        self.threads.set_api_key(api_key)

        return self

    def set_timeout(self, timeout: int):
        """
        Sets the timeout for the entire SDK.

        :param int timeout: The timeout (ms) to be set.
        :return: The SDK instance.
        """
        self.system.set_timeout(timeout)
        self.agents.set_timeout(timeout)
        self.execution.set_timeout(timeout)
        self.analysis.set_timeout(timeout)
        self.schema.set_timeout(timeout)
        self.threads.set_timeout(timeout)

        return self


# c029837e0e474b76bc487506e8799df5e3335891efe4fb02bda7a1441840310c
