# This file was generated by liblab | https://liblab.com/

from typing import Union
from .net.environment import Environment
from .sdk import HeadlessAgents
from .services.async_.system import SystemServiceAsync
from .services.async_.agents import AgentsServiceAsync
from .services.async_.execution import ExecutionServiceAsync
from .services.async_.analysis import AnalysisServiceAsync
from .services.async_.schema import SchemaServiceAsync
from .services.async_.threads import ThreadsServiceAsync


class HeadlessAgentsAsync(HeadlessAgents):
    """
    HeadlessAgentsAsync is the asynchronous version of the HeadlessAgents SDK Client.
    """

    def __init__(
        self,
        api_key: str = None,
        base_url: Union[Environment, str] = Environment.DEFAULT,
        timeout: int = 60000,
    ):
        super().__init__(
            api_key=api_key,
            base_url=base_url,
            timeout=timeout,
        )

        self.system = SystemServiceAsync(base_url=self._base_url)
        self.agents = AgentsServiceAsync(base_url=self._base_url)
        self.execution = ExecutionServiceAsync(base_url=self._base_url)
        self.analysis = AnalysisServiceAsync(base_url=self._base_url)
        self.schema = SchemaServiceAsync(base_url=self._base_url)
        self.threads = ThreadsServiceAsync(base_url=self._base_url)
