# This file was generated by liblab | https://liblab.com/

from .utils.validator import Validator
from .utils.base_service import BaseService
from ..net.transport.serializer import Serializer
from ..models.utils.cast_models import cast_models
from ..models import CreateDigestOkResponse, DigestRequest


class AnalysisService(BaseService):

    @cast_models
    def create_digest(self, request_body: DigestRequest) -> CreateDigestOkResponse:
        """Analyze a user objective across multiple agents to determine relevance and capabilities

        :param request_body: The request body.
        :type request_body: DigestRequest
        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: The parsed response data.
        :rtype: CreateDigestOkResponse
        """

        Validator(DigestRequest).validate(request_body)

        serialized_request = (
            Serializer(f"{self.base_url}/digest", self.get_default_headers())
            .serialize()
            .set_method("POST")
            .set_body(request_body)
        )

        response, _, _ = self.send_request(serialized_request)
        return CreateDigestOkResponse._unmap(response)
