# This file was generated by liblab | https://liblab.com/

from .utils.validator import Validator
from .utils.base_service import BaseService
from ..net.transport.serializer import Serializer
from ..models.utils.cast_models import cast_models
from ..models import CallAgentOkResponse, CallAgentRequest


class ExecutionService(BaseService):

    @cast_models
    def call_agent(
        self, request_body: CallAgentRequest, agent_id: str
    ) -> CallAgentOkResponse:
        """Send a request to an agent and receive its response. Handles both standard AI agents and platform-integrated agents.

        :param request_body: The request body.
        :type request_body: CallAgentRequest
        :param agent_id: ID of the agent to call
        :type agent_id: str
        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: The parsed response data.
        :rtype: CallAgentOkResponse
        """

        Validator(CallAgentRequest).validate(request_body)
        Validator(str).validate(agent_id)

        serialized_request = (
            Serializer(f"{self.base_url}/call/{{agent_id}}", self.get_default_headers())
            .add_path("agent_id", agent_id)
            .serialize()
            .set_method("POST")
            .set_body(request_body)
        )

        response, _, _ = self.send_request(serialized_request)
        return CallAgentOkResponse._unmap(response)
