# This file was generated by liblab | https://liblab.com/

from .utils.validator import Validator
from .utils.base_service import BaseService
from ..net.transport.serializer import Serializer
from ..models.utils.cast_models import cast_models
from ..models import CreateSchemaOkResponse, SchemaCreateRequest


class SchemaService(BaseService):

    @cast_models
    def create_schema(
        self, request_body: SchemaCreateRequest
    ) -> CreateSchemaOkResponse:
        """Generate a JSON schema definition from natural language description

        :param request_body: The request body.
        :type request_body: SchemaCreateRequest
        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: The parsed response data.
        :rtype: CreateSchemaOkResponse
        """

        Validator(SchemaCreateRequest).validate(request_body)

        serialized_request = (
            Serializer(f"{self.base_url}/schema/create", self.get_default_headers())
            .serialize()
            .set_method("POST")
            .set_body(request_body)
        )

        response, _, _ = self.send_request(serialized_request)
        return CreateSchemaOkResponse._unmap(response)
