# This file was generated by liblab | https://liblab.com/

from .utils.validator import Validator
from .utils.base_service import BaseService
from ..net.transport.serializer import Serializer
from ..models.utils.cast_models import cast_models
from ..models import HealthCheckOkResponse


class SystemService(BaseService):

    @cast_models
    def health_check(self) -> HealthCheckOkResponse:
        """Simple health check endpoint to verify the API server is running and responsive

        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: The parsed response data.
        :rtype: HealthCheckOkResponse
        """

        serialized_request = (
            Serializer(f"{self.base_url}/health", self.get_default_headers())
            .serialize()
            .set_method("GET")
        )

        response, _, _ = self.send_request(serialized_request)
        return HealthCheckOkResponse._unmap(response)
