# This file was generated by liblab | https://liblab.com/

from .utils.validator import Validator
from .utils.base_service import BaseService
from ..net.transport.serializer import Serializer
from ..models.utils.cast_models import cast_models
from ..models import Thread


class ThreadsService(BaseService):

    @cast_models
    def get_thread(self, thread_id: str) -> Thread:
        """Retrieve a specific thread and its messages by thread ID

        :param thread_id: Unique identifier of the thread
        :type thread_id: str
        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: The parsed response data.
        :rtype: Thread
        """

        Validator(str).validate(thread_id)

        serialized_request = (
            Serializer(
                f"{self.base_url}/thread/{{thread_id}}", self.get_default_headers()
            )
            .add_path("thread_id", thread_id)
            .serialize()
            .set_method("GET")
        )

        response, _, _ = self.send_request(serialized_request)
        return Thread._unmap(response)
